Zavrsni/urls.py
from django.contrib import admin
from django.urls import path
from django.conf.urls import include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('users/', include('users.urls')),
    path('comm/', include('common.urls')),
    path('unis/', include('unis.urls')),
    path('relations/', include('relations.urls')),
    path('', include('posts.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root= settings.MEDIA_ROOT)

posts/urls.py
from django.urls import path
from . import views
from .views import PostListVieW, PostDetailView, PostUpdateView, PostDeleteView, \
    AboutUniUpdateView, FinanceDeleteView, FinanceUpdateView, \
    AboutCityUpdateView, HomeListVieW, FinanceListVieW, \
    FinanceCreateVieW, MediaListView, MediaDeleteView
from common.views import CityDetailView

urlpatterns = [
    path('', HomeListVieW.as_view(), name="home"),

    path('posts', PostListVieW.as_view(), name="post-list"),
    path('aboutcities/<int:pk>/', CityDetailView.as_view(), name="aboutcity-list"),
    path('finances/<int:pk>/', FinanceListVieW.as_view(), name="finance-list"),

    path('posts/<int:pk>/', PostDetailView.as_view(), name="post-detail"),

    path('posts/<int:pk>/update', PostUpdateView.as_view(), name="post-update"),
    path('posts/aboutuni/<int:pk>/update', AboutUniUpdateView.as_view(), name="aboutuni-update"),
    path('posts/aboutcity/<int:pk>/update', AboutCityUpdateView.as_view(), name="aboutcity-update"),
    path('finances/<int:pk>/update', FinanceUpdateView.as_view(), name="finance-update"),

    path('posts/<int:pk>/delete', PostDeleteView.as_view(), name="post-delete"),
    path('finances/<int:pk>/delete', FinanceDeleteView.as_view(), name="finance-delete"),
    path('images/<int:pk>/delete', MediaDeleteView.as_view(), name="media-delete"),

    path('posts/new/', views.bigpost, name="post-create"),
    path('finances/<int:pk>/new/', FinanceCreateVieW.as_view(), name="finance-create"),

    path('images/<int:pk>/add/', views.saveimage,  name="media-upload"),
    path('images/', MediaListView.as_view(), name="media-list"),

    path('links/', views.links, name="links"),


]

unis/urls.py
from django.urls import path
from unis.views import CroUniListVieW, ExUniListVieW, ExUniDetailView, CroUniDetailView, CroUniListVieWSecond

urlpatterns = [
    path('exunis/', ExUniListVieW.as_view(), name="ex-list"),
    path('crounis/', CroUniListVieW.as_view(template_name='unis/crounis1.html'), name="cro-list"),
    path('crounis2/<int:pk>', CroUniListVieWSecond.as_view(template_name='unis/crounis.html'), name="cro-list2"),
    path('exunis/<int:pk>/', ExUniDetailView.as_view(), name="exuni-detail"),
    path('crounis/<int:pk>/', CroUniDetailView.as_view(), name="crouni-detail"),
]

posts/models.py
from django.db import models
from users.models import CustomUser
from django.urls import reverse
from relations.models import Relation
from unis.models import ExUni
from common.models import City, FinanceType
from PIL import Image
from django.core.validators import MaxValueValidator, MinValueValidator


class Post(models.Model):
    author = models.OneToOneField(CustomUser, on_delete=models.SET_NULL, null=True, blank=True)
    relation = models.ForeignKey(Relation, on_delete=models.SET_NULL, null=True, blank=True)

    title = models.CharField(max_length=100, default="")
    ex_year = models.IntegerField(default=2019, blank=False, validators=[
            MinValueValidator(1975),
            MaxValueValidator(2019)
        ])
    generally = models.TextField(blank=True, null=True)
    last_modified = models.DateTimeField('date_published', auto_now=True)

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.pk})

class AboutCity(models.Model):
    city = models.ForeignKey(City, on_delete=models.CASCADE, null=True)
    post = models.OneToOneField(Post, on_delete=models.CASCADE, null=True)

    places_to_see = models.TextField(blank=True, null=True)
    city_traffic = models.TextField(blank=True, null=True)
    how_to_arrive = models.TextField(blank=True, null=True)
    where_to_go = models.TextField(blank=True, null=True)
    food = models.TextField(blank=True, null=True)

    def __str__(self):
        return self.city.name

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.post.pk})

class AboutUni(models.Model):
    ex_uni = models.ForeignKey(ExUni, on_delete=models.CASCADE, null=True)
    post = models.OneToOneField(Post, on_delete=models.CASCADE, null=True)

    generally = models.TextField(blank=True, null=True)
    prof = models.TextField(blank=True, null=True)
    subjects = models.TextField(blank=True, null=True)

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'pk': self.post.pk})

    def __str__(self):
        return self.ex_uni.name

class Media(models.Model):
    post = models.ForeignKey(Post, null=True, blank=True, on_delete=models.CASCADE)

    myimage = models.FileField(upload_to='images/', null=True, verbose_name="")

    def __str__(self):
        return str(self.myimage)

    #resize
    def save(self, *args, **kwargs):
        super().save(*args, **kwargs)
        img = Image.open(self.myimage.path)

        if img.height > 700 or img.width > 700:
            output_size = (700, 700)
            img.thumbnail(output_size)
            img.save(self.myimage.path)



class Finance(models.Model):
    finance_type = models.ForeignKey(FinanceType, on_delete=models.CASCADE)
    post = models.ForeignKey(Post, on_delete=models.CASCADE)
    amount = models.PositiveIntegerField(default=0)
    ordering = ['amount']

    def __str__(self):
        return self.finance_type.__str__() + "-" + self.amount.__str__()

    def get_absolute_url(self):
        return reverse('finance-list', kwargs={'pk': self.post.pk})

    class Meta:
        unique_together = (("finance_type", 'post'),)

posts/forms.py
from django.forms import ModelForm
from .models import Post, AboutCity, AboutUni, Media, Finance


class AboutUniForm(ModelForm):
    class Meta:
        model = AboutUni
        fields = ['generally', 'prof', 'subjects', 'ex_uni']


class AboutCityForm(ModelForm):
    class Meta:
        model = AboutCity
        fields = ['city', 'places_to_see', 'city_traffic', 'how_to_arrive', 'where_to_go', 'food']


class PostForm(ModelForm):
    class Meta:
        model = Post
        fields = ['generally', 'title', 'ex_year', 'relation']


class MediaForm(ModelForm):
    class Meta:
        model = Media
        fields = ['myimage']

'''
class FinanceForm(ModelForm):
    class Meta:
        model = Finance
        fields = ['finance_type', 'amount']
'''

posts/views.py
from django.shortcuts import render, redirect
from django.urls import reverse_lazy
from django.views.generic import (ListView, DetailView,	CreateView,	UpdateView,	DeleteView)
from django.contrib import messages
from .models import Post, AboutUni, AboutCity, Finance, Media, FinanceType
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin
from .forms import AboutCityForm, AboutUniForm, PostForm, MediaForm #, FinanceForm
from users.models import CustomUser
from django.db import IntegrityError
from django.http import HttpResponse




#home
class HomeListVieW(ListView):
    model = Post
    template_name = 'posts/home.html'
    context_object_name = 'posts'
    ordering = ['-last_modified']


#list
class PostListVieW(ListView):
    model = Post
    template_name = 'posts/posts.html'
    context_object_name = 'posts'
    ordering = ['-last_modified']
    paginate_by = 2

class FinanceListVieW(ListView):
    model = Finance
    template_name = 'posts/finance_list.html'
    context_object_name = 'finances'


#update
class PostUpdateView(LoginRequiredMixin, UserPassesTestMixin, UpdateView):
    model = Post
    fields = ['generally', 'title', 'ex_year', 'relation']

    def form_valid(self, form):
        form.instance.author = self.request.user
        messages.success(self.request, f'Your post has been updated!')
        return super().form_valid(form)

    def test_func(self):
        post = self.get_object()
        if self.request.user == post.author:
            return True
        else:
            return False


class AboutUniUpdateView(LoginRequiredMixin, UserPassesTestMixin, UpdateView):
    model = AboutUni
    fields = ['generally', 'prof', 'subjects', 'ex_uni']

    def form_valid(self, form):
        form.instance.author = self.request.user
        messages.success(self.request, f'Your post has been updated!')
        return super().form_valid(form)

    def test_func(self):
        aboutuni = self.get_object()
        if self.request.user == aboutuni.post.author:
            return True
        else:
            return False


class AboutCityUpdateView(LoginRequiredMixin, UserPassesTestMixin, UpdateView):
    model = AboutCity
    fields = ['city', 'places_to_see', 'city_traffic', 'how_to_arrive', 'where_to_go', 'food']

    def form_valid(self, form):
        form.instance.author = self.request.user
        messages.success(self.request, f'Your post has been updated!')
        return super().form_valid(form)

    def test_func(self):
        aboutcity = self.get_object()
        if self.request.user == aboutcity.post.author:
            return True
        else:
            return False


class FinanceUpdateView(LoginRequiredMixin, UserPassesTestMixin, UpdateView):
    model = Finance
    fields = ['amount']

    def form_valid(self, form):
        form.instance.post.author = self.request.user
        messages.success(self.request, f'Your expense has been updated!')
        return super().form_valid(form)

    def test_func(self):
        finance = self.get_object()
        if self.request.user == finance.post.author:
            return True
        else:
            return False


#detail
class PostDetailView(DetailView):
    model = Post

#delete
class PostDeleteView(LoginRequiredMixin, UserPassesTestMixin, DeleteView):
    model = Post
    success_url = '/'

    def test_func(self):
        post = self.get_object()
        if self.request.user == post.author:
            return True
        else:
            return False


class FinanceDeleteView(LoginRequiredMixin, UserPassesTestMixin, DeleteView):
    model = Finance

    def test_func(self):
        finance = self.get_object()
        if self.request.user == finance.post.author:
            return True
        else :
            return False

    def get_success_url(self):
        return reverse_lazy('finance-list', kwargs={'pk':self.get_object().post.id})


#create
@login_required
def bigpost(request):
    if request.method == 'POST':
        au_form = AboutUniForm(request.POST)
        ac_form = AboutCityForm(request.POST)
        form = PostForm(request.POST)

        if form.is_valid() and ac_form.is_valid() and au_form.is_valid():
            post = form.save(commit=False)
            post.author = request.user
            post.save()
            aboutuni = au_form.save(commit=False)
            aboutcity = ac_form.save(commit=False)

            aboutuni.post = post
            aboutcity.post = post

            aboutcity.save()
            aboutuni.save()

            messages.success(request, f'Your post has been created.')
            return redirect('post-detail', post.id)

    else:
        au_form = AboutUniForm()
        ac_form = AboutCityForm()
        form = PostForm()

    context = {
        'form': form,
        'au_form': au_form,
        'ac_form': ac_form,
    }
    return render(request, 'posts/post_create.html', context)

class FinanceCreateVieW(LoginRequiredMixin, CreateView):
    model = Finance
    fields = ['finance_type', 'amount']
    template_name = 'posts/finance_form.html'

    def form_valid(self, form):
        form.instance.post = self.request.user.post
        try:
            return super().form_valid(form)
        except IntegrityError:
            messages.error(self.request, f'That type of expense already exist. You can edit it.')
            return redirect('finance-list', pk=self.request.user.post.id)


#image

def saveimage(request, pk):
    form = MediaForm(request.POST or None, request.FILES or None)
    if form.is_valid():
        messages.success(request, f'Your picture has been uploaded!')
        media = form.save(commit=False)
        postid = CustomUser.objects.get(pk=pk).post.id
        media.post = Post.objects.get(pk=postid)
        media.save()
    context = {'form': form}
    return render(request, 'posts/images.html', context)


class MediaListView(ListView):
    model = Media
    template_name = 'posts/showimages.html'
    context_object_name = 'images'
    paginate_by = 2

class MediaDeleteView(LoginRequiredMixin, UserPassesTestMixin, DeleteView):
    model = Media

    def test_func(self):
        img = self.get_object()
        if self.request.user == img.post.author:
            return True
        else:
            return False

    def get_success_url(self):
        return reverse_lazy('post-detail', kwargs={'pk':self.get_object().post.id})

def links(request):
    return render(request, 'posts/links.html')

posts/templates/posts/aboutcity_form.html
{% extends "posts/base.html"%}
<!-- aboutuni new -->
{% load static %}
{% load crispy_forms_tags %}
{% block page_content %}
<font color=black>
{% block content %}
<font color="black">

    <div id="page" class="container">
        <section>
        <form method="POST">
            {% csrf_token %}
            <fieldset class="form-group">
                <p><label>City:</label> {{ form.city }}</p>
                <p><label>How to arrive:</label>{{ form.how_to_arrive }}</p>
                <p><label>City traffic:</label>{{ form.city_traffic }}</p>
                <p><label>Places to see in the city:</label>{{ form.places_to_see }}</p>
                <p><label>Where to go near the city:</label>{{ form.where_to_go }}</p>
                <p><label>Food:</label>{{ form.food }}</p>
            </fieldset>
            <div class="form-group">
                <button class="button" type="submit">Post</button>
                    <p><a href="{% url 'post-detail' user.post.id %}">Back</a></p>

            </div>
        </form>
        </section>
</div>
</font>
{% endblock %}
</font>
{% endblock %}

posts/templates/posts/aboutuni_form.html
{% extends "posts/base.html"%}
<!-- aboutuni new -->
{% load static %}
{% load crispy_forms_tags %}
{% block page_content %}
<font color=black>

{% block content %}
    <div id="page" class="container">
        <section>
        <form method="POST">
            {% csrf_token %}
            <fieldset class="form-group">
                <p><label for="id_title">University:</label>    {{ form.ex_uni }}</p>
                <p><label for="id_title">About university:</label>{{ form.generally }}</p>
                {{ form.name.errors}}
                 <p><label for="id_ex_year">Professors:</label>{{ form.prof }}</p>
                 <p><label for="id_generally" placeholder="You can type here">Subjects:</label> {{ form.subjects }}</p>
            </fieldset>
            <div class="form-group">
                <button class="button" type="submit">Post</button>
                    <p><a href="{% url 'post-detail' user.post.id %}">Back</a></p>

            </div>
        </form>
        </section>
</div>
{% endblock %}
</font>
{% endblock %}

posts/templates/posts/base.html
{% load static %}
<!DOCTYPE HTML>
<html>
	<head>
		<title>ERASMUS+ web guid</title>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<meta name="description" content="" />
		<meta name="keywords" content="" />
		<!--[if lte IE 8]><script src="{% static "posts/css/ie/html5shiv.js" %}"></script><![endif]-->
		<script src="{% static 'posts/js/jquery.min.js' %}"></script>
		<script src="{% static 'posts/js/jquery.dropotron.min.js' %}"></script>
		<script src="{% static 'posts/js/skel.min.js' %}"></script>
		<script src="{% static 'posts/js/skel-layers.min.js' %}"></script>
		<script src="{% static 'posts/js/init.js' %}"></script>
        <script src="https://cdn.jsdelivr.net/npm/chart.js@2.8.0"></script>
		<noscript>
			<link rel="stylesheet" href="{% static 'posts/css/skel.css' %}"/>
			<link rel="stylesheet" href="{% static 'posts/css/style.css' %}" />
			<link rel="stylesheet" href="{% static 'posts/css/style-wide.css' %}" />
		</noscript>
		<!--[if lte IE 8]><link rel="stylesheet" href="{% static "posts/css/ie/v8.css" %}" /><![endif]-->
	</head>
	<body>

		<!-- Wrapper -->
			<div class="wrapper style1">

				<!-- Header -->
					<div id="header" class="skel-panels-fixed">
						<div id="logo">
							<h1><a href="{% url "home" %}">ERASMUS+</a></h1>
							<span class="tag"> web guid</span>
						</div>
						<nav id="nav">
							<ul>
                                {% if user.is_authenticated %}
                                    {% if user.post %}
                                    <li><a href={% url 'post-detail' user.post.id %}>My posts</a></li>
                                    {% else %}
                                    <li><a  href={% url 'post-create' %}>New Post</a></li>
                                    {% endif %}
                                    <li><a  href={% url 'profile' %}>Profile {{ user.username }}</a></li>
                                    <li><a  href={% url 'logout' %}>Logout</a></li>
                                {% else %}
                                    <li><a  href={% url 'login' %}>Login</a></li>
                                    <li><a  href="{% url 'register' %}">Register</a></li>
                                {% endif %}
							</ul>
						</nav>
					</div>

            {% if messages %}
          		<!-- Content -->
                <div class="6u">
                    <section>
                        <ul class="style">
                            {% for message in messages %}
                            <li>
                            <span><div class="alert alert-{{ message.tags }}">
                                    {{ message }}
                                </div>
                            </span> </li>
                            {% endfor %}
                        </ul>
                    </section>
                </div>
            {% endif %}

				<!-- Banner -->
                {% block main_banner %}
                {% endblock %}

             <!-- Page -->
                {% block page_content %}

                {% block sidebar %}

                {% endblock sidebar %}
                {% block content %}
                {% endblock content%}

                {% endblock %}

				<!-- Main -->
                {% block out_box_sections %}
                {% endblock %}

                <!-- Extra -->
                {% block box_sections %}
                {% endblock %}

		</div>
	</div>

	<!-- Copyright -->
		<div id="copyright">
            <ul>
                <li><a>Ova aplikacija je nastala u sklopu izrade završnog rada.</a></li>
                <li><a>Matea Mijočević, Mentorica: Mirta Baranović</a></li>
                <p></p>
                <li><a>©Copyright - FER 2019</a></li>
                <li><a>Unska 3, 10000 Zagreb, Republika Hrvatska</a></li>
                <li><a>ERASMUS® is a registered trademark owned by the European Union and represented by the European Commission.</a></li>
                <li><a>This website is not related in any way to the ERASMUS® trademark, European Union and the European Commission either.</a></li>
            </ul>
		</div>

	</body>
</html>

posts/templates/posts/finance_form.html
{% extends "posts/base.html"%}
<!-- aboutuni new -->
{% load static %}
{% load crispy_forms_tags %}
{% block page_content %}
<font color=black>

{% block content %}
    <div id="page" class="container">
        <section>
        <form method="POST">
            {% csrf_token %}
            <fieldset class="form-group">
                {% if form.finance_type %}
                <p><label>Type of expenses:</label> {{ form.finance_type }}</p>
                {% else %}
                    <p><b>{{ object.finance_type.type }}</b></p>
                {% endif %}
                {{ form.finance_type.erros }}
                <p><label>Amount in kunas:</label>{{ form.amount }}</p>
                {{ form.erros }}
            </fieldset>
            <div class="form-group">
                <button class="button" type="submit">Post</button>
            </div>
        </form>
        </section>
</div>
{% endblock %}
</font>
{% endblock %}

posts/templates/posts/finance_list.html
{% extends "posts/base.html"%}
{% block page_content %}
<font color=black>

    <div id="page" class="container">
            <section>
                <header class="major">
                    <h2>Your monthly expenses on exchange experience</h2>

                    <a href="{% url 'finance-create' user.post.id %}">Add new one</a>
               </header>
              {% for fin in finances %}
                  {% if fin.post.author == user %}
                <p>{{ fin }} kn <a href="{% url 'finance-update'  fin.id %}">Edit</a> <a href="{% url 'finance-delete' fin.id %}">Delete</a> </p>
                {% endif %}
            {% endfor %}
            <p><a href="{% url 'post-detail' user.post.id %}">Back</a></p>

            </section>
    <!-- chart -->
        </div>
</font>
{% endblock %}

posts/templates/posts/home.html
{% extends 'posts/base.html' %}
{% block main_banner %}

    <div id="banner" class="container">
        <section>
            <p>Welcome to an <strong>ERASMUS+</strong> web guid!</p>
            <p>Explore others, and share with us your exchange experience.</p>
            <p><a href="{% url 'links' %}" class="button">Prepare for ERASMUS</a></p>

        </section>
    </div>


{% endblock main_banner %}

{% block out_box_sections %}
    <div class="container">
        <div class="row">

            <!-- Content -->
            <div class="6u">
                <section>
                    <ul class="style">
                        <li>
                            <h3>Explore studets reviews:</h3>
                            <a href="{% url 'post-list' %}" class="button">Go</a>
                        <li>
                            <h3>Explore reviews by exchange university:</h3>
                            <a href="{% url 'ex-list' %}" class="button">Go</a>
                        <li>
                          <h3>Explore every possible exchange relation</h3>
                          <a href="{% url 'relation-list' %}" class="button">Go</a>
                        <li>

                    </ul>
                </section>
            </div>
            <div class="6u">
                <section>
                    <ul class="style">
                        <li>
                         <h3>Explore reviews by city:</h3>
                        <a href="{% url 'city-list' %}" class="button">Go</a>
                        <li>
                            <h3>Explore reviews by croatian university:</h3>
                            <a href="{% url 'cro-list' %}" class="button">Go</a>
                        <li>
                           <h3>Galery:</h3>
                            <a href="{% url 'media-list' %}" class="button">Go</a>
                        <li>

                    </ul>
                </section>
            </div>
           </div>
    </div>
{% endblock out_box_sections %}

{% block box_sections %}

    <div id="banner" class="container">
        <section>
            <h2><p><strong>Latest reviews:</strong></p></h2>
        </section>
    </div>

<div id="extra">
    <div class="container">
        <div class="row no-collapse-1">
            {% for post in posts|slice:":3"  %}
            <section class="4u">
                <div class="box">
                    <font color="black">

                    <h1>{{ post.title }}</h1>
                    <b>({{ post.aboutcity.city.name }} - {{ post.ex_year }})</b>
                    <p>{{ post.generally|slice:":100" }}...</p>
                        <a href="{% url 'post-detail' post.id %}" class="button">Read More</a> </font></div>
            </section>

          {% endfor %}
       </div>
    </div>
</div>

{% endblock %}

posts/templates/posts/images.html
{% extends "posts/base.html"%}
{% block page_content %}
    <font color=black>

    <div id="page" class="container">
            <section>
                <header class="major">
                    <h2>Image uploader</h2>
                </header>
                    <form enctype="multipart/form-data" method="POST" action="">
                    {% csrf_token %}
                    <p>{{ form.as_p }}</p>
                        {{ form.non_field_errors }}
                    <p><input type="submit" value="Upload"/></p>
                    <p><a href="{% url 'post-detail' user.post.id %}">Back</a></p>
                    </form>
            </section>
        </div>
    </font>
{% endblock %}

posts/templates/posts/post_detail.html
{% extends "posts/base.html"%}
{% block page_content %}

{% if object.author == user %}

    <div id="main">
        <div class="container">
            <div class="row">

                <!-- Content -->
                <div class="6u">
                    <section>
                           <a href="{% url 'finance-list' user.id %}" class="button">Arrange your financial chart</a>
                    </section>
                </div>
                <div class="6u">
                    <section>
                           <a href="{% url 'media-upload' user.id %}" class="button">Add pictures</a>
                        <ul>
                        </ul>
                    </section>
                </div>
            </div>
        </div>
    </div>
{% endif %}




<font color="black">

    <div id="page" class="container">
    <div class="row">
    {% block sidebar %}
        <div id="sidebar" class="4u">
        <section>
            <header class="major">
                <h2>Details:</h2>
            </header>
            <div class="row half">
                <section class="6u">
                    <ul class="default">
                        {% if object.author %}
                        <li><b>Author: <br>{{ object.author }}, {{ object.relation.cro_uni }}</b></li>
                        {% else %}
                        <li><font color="red">Erased profile</font></li>
                        {% endif %}
                        <li><b>{{ object.relation.ex_uni }}, {{ object.ex_year }}</b></li>
                        <li><b>Programm: {{ object.relation.program.short_name }}</b><br><b>ISCED Area: {{ object.relation.ISCED_Area }}</b></li>
                        {% if object.finance_set.count > 0 %}
                        <li><b>Monthly expenses:</b> <br>
                            {% for o in object.finance_set.all %}
                            <b>{{ o.finance_type.type }} - {{ o.amount }} kn<br></b>
                            {% endfor %}

                        {% endif %}
                    </li>
                    </ul>
                </section>
            </div>
        </section>
    </div>
    {% endblock sidebar %}
{% block content %}
    <div id="content" class="8u skel-cell-important">
        <section>
            <header class="major">
                <h2>{{ object.title }}</h2>
                <span class="byline">{{ object.last_modified|date:"F d, Y" }}</span>
                {% if object.author == user %}
                    <div>
                        <a class = "btn btn-secondary btn-sm mt-1 mb-1" href={% url 'post-update' object.id %}>Update</a>
                        <a class = "btn btn-danger btn-sm mt-1 mb-1" href={% url 'post-delete' object.id %}>Delete</a>
                    </div>
                {% endif %}
           </header>
            <p class="article-content">{{ object.generally }}</p>
            <canvas id="barChart"></canvas>

          </section>
    </div>

{% endblock %}
    </div>
    </div>

    <p></p><p></p>

    <div id="page" class="container">
            <section>
                <header class="major">
                    <h2>University review - {{ object.aboutuni.ex_uni.name }}</h2>
                     {% if object.author == user %}
                     <a class = "btn btn-secondary btn-sm mt-1 mb-1" href={% url 'aboutuni-update' object.aboutuni.id %}>Update</a>
                    {% endif %}

                </header>
                {% if object.aboutuni.generally %}
                <b class="byline">ABOUT UNIVERSITY:</b>
                {% endif %}
                <p>{{ object.aboutuni.generally }}</p>
                {% if object.aboutuni.prof %}
                <b class="byline">PROFESSORS:</b>
                {% endif %}
                <p>{{ object.aboutuni.prof }}</p>
                {% if object.aboutuni.subjects %}
                <b class="byline">SUBJECTS:</b>
                {% endif %}
                <p>{{ object.aboutuni.subjects }}</p>

            </section>
        </div>

        <p></p><p></p>

        <div id="page" class="container">
            <section>
                <header class="major">
                    <h2>City review - {{ object.aboutcity.city }}</h2>
                 {% if object.author == user %}
                     <a class = "btn btn-secondary btn-sm mt-1 mb-1" href={% url 'aboutcity-update' object.aboutcity.id %}>Update</a>
                 {% endif %}
                </header>
                {% if object.aboutcity.how_to_arrive %}
                <b class="byline">HOW TO ARRIVE:</b>
                {% endif %}
                <p>{{ object.aboutcity.how_to_arrive }}</p>
                 {% if object.aboutcity.city_traffic %}
               <b class="byline">CITY TRAFFIC:</b>
                {% endif %}
                <p>{{ object.aboutcity.city_traffic }}</p>
                {% if object.aboutcity.places_to_see %}
                <b class="byline">PLACES TO SEE IN THE CITY:</b>
                {% endif %}
                <p>{{ object.aboutcity.places_to_see }}</p>
                {% if object.aboutcity.where_to_go %}
                <b class="byline">WHERE TO GO AROUND THE CITY:</b>
                {% endif %}
                <p>{{ object.aboutcity.where_to_go }}</p>
                {% if object.aboutcity.food %}
                <b class="byline">FOOD:</b>
                {% endif %}
                <p>{{ object.aboutcity.food }}</p>

            </section>
        </div>

      <p></p><p></p>

    {% if object.media_set.count > 0 %}
        <div id="page" class="container">
            <section>
                <header class="major">
                    <h2>Images</h2>
                </header>
            {% for im in object.media_set.all %}
                {% if im.post.id == object.id %}
                <img src='{{ MEDIA_URL }}{{ im.myimage }}'>
                {% if object.author == user %}
                        <a  href={% url 'media-delete' im.id %}>Delete</a>
                {% endif %}
                <p></p>
                {% endif %}
            {% endfor %}

            </section>
</div>
    {% endif %}

{% endblock %}

</font>